<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CommandSupport xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/base/utils/CommandSupport.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.base.utils;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Collections;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionEvent;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionException;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.operations.IOperationHistory;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.operations.IUndoableOperation;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.operations.OperationHistoryFactory;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IAdaptable;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.NullProgressMonitor;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.TransactionalEditingDomain;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.util.TransactionUtil;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.common.core.command.CommandResult;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.Activator;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.Messages;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServiceException;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.ui.util.ServiceUtilsForHandlers;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * Utility function. Allow execution of commands on a transactional command stack</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment"> * @author ansgar</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/CommandSupport.html">CommandSupport</a> {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * Execute the passed Runnable within a command</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 * @param label</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * @param command</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> exec(String label, ExecutionEvent event, <strong class="jxr_keyword">final</strong> Runnable command) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		ServiceUtilsForHandlers serviceUtils = ServiceUtilsForHandlers.getInstance();
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  			exec(serviceUtils.getTransactionalEditingDomain(event), label, command);
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		} <strong class="jxr_keyword">catch</strong> (ServiceException e) {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  			Activator.log.error(Messages.CommandSupport_NoEditingDomain, e);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * Execute the passed Runnable within a command</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 * @param eObject an element of the model that is modified (domain will be determined from it)</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 * @param label A command label</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 * @param command The command in form of a runnable</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> exec(EObject eObject, String label, <strong class="jxr_keyword">final</strong> Runnable command) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		exec(TransactionUtil.getEditingDomain(eObject), label, command);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	}
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 * Execute the passed Runnable with result within a command</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <em class="jxr_javadoccomment">	 * @param label</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 * @param command</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> exec(String label, ExecutionEvent event, <strong class="jxr_keyword">final</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/RunnableWithResult.html">RunnableWithResult</a> command) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<em class="jxr_comment">// ServiceUtilsForActionHandlers serviceUtils = ServiceUtilsForActionHandlers.getInstance();</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		ServiceUtilsForHandlers serviceUtils = ServiceUtilsForHandlers.getInstance();
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		IOperationHistory history = OperationHistoryFactory.getOperationHistory();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			history.execute(<strong class="jxr_keyword">new</strong> AbstractTransactionalCommand(serviceUtils.getTransactionalEditingDomain(event),
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  					label, Collections.EMPTY_LIST) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  				@Override
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  				<strong class="jxr_keyword">public</strong> CommandResult doExecuteWithResult(IProgressMonitor dummy, IAdaptable info) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  					<strong class="jxr_keyword">return</strong> command.run();
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  				}
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			}, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		<strong class="jxr_keyword">catch</strong> (ExecutionException e) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			Activator.log.error(Messages.CommandSupport_ErrorDuringCmdExec, e);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<strong class="jxr_keyword">catch</strong> (ServiceException e) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			Activator.log.error(Messages.CommandSupport_NoEditingDomain, e);
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		}
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 * Execute the passed Runnable within a command</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">	 * @param label</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 * @param command</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> exec(TransactionalEditingDomain domain, String label, <strong class="jxr_keyword">final</strong> Runnable command) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">if</strong> (domain == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			command.run();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			IOperationHistory history = OperationHistoryFactory.getOperationHistory();
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				history.execute(<strong class="jxr_keyword">new</strong> AbstractTransactionalCommand(domain, label, Collections.EMPTY_LIST) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 					@Override
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 					<strong class="jxr_keyword">public</strong> CommandResult doExecuteWithResult(IProgressMonitor dummy, IAdaptable info) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 						command.run();
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 						<strong class="jxr_keyword">return</strong> CommandResult.newOKCommandResult();
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 					}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				}, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			} <strong class="jxr_keyword">catch</strong> (ExecutionException e) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 				Activator.log.error(e);
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		}
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 	}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> exec(IUndoableOperation command) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		IOperationHistory history = OperationHistoryFactory.getOperationHistory();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			history.execute(command, <strong class="jxr_keyword">new</strong> NullProgressMonitor(), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		} <strong class="jxr_keyword">catch</strong> (ExecutionException e) {
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			Activator.log.error(e);
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
